/*
 * Copyright 2011 by Emese Revfy <re.emese@gmail.com>
 * Copyright 2011-2021 by PaX Team <pageexec@freemail.hu>
 * Licensed under the GPL v2
 */

#include "constify.h"

static unsigned int check_local_variables_execute(void)
{
	tree var;
	unsigned int i;

	FOR_EACH_LOCAL_DECL(cfun, i, var) {
		tree type;

		gcc_assert(DECL_P(var));
		if (is_global_var(var))
			continue;

		type = strip_array_types(TREE_TYPE(var));
		if (TREE_CODE(type) != RECORD_TYPE && TREE_CODE(type) != UNION_TYPE)
			continue;

		if (!TYPE_READONLY(type) || !C_TYPE_FIELDS_READONLY(type))
			continue;

		if (!TYPE_CONSTIFY_VISITED(type))
			continue;

		error_at(DECL_SOURCE_LOCATION(var), "constified variable %qE of type %qT cannot be local", var, type);
	}

	return 0;
}

#define PASS_NAME check_local_variables
#define NO_GATE
#include "gcc-generate-gimple-pass.h"
