#ifndef CONSTIFY_H_INCLUDED
#define CONSTIFY_H_INCLUDED

#include "gcc-common.h"
#include "gcc-ksyms.h"

// attrs
// unused C type flag in all versions 4.5-11
#define TYPE_CONSTIFY_VISITED(TYPE) TYPE_LANG_FLAG_4(TYPE)

extern struct attribute_spec no_const_attr;
extern struct attribute_spec do_const_attr;
extern struct attribute_spec mutable_const_attr;
extern struct attribute_spec mutable_const_performed_attr;

// plugin <-> target interaction
extern GTY(()) tree pax_open_kernel_decl;
extern GTY(()) tree pax_close_kernel_decl;

// misc
#define RODATA_MUTABLE_READ_MOSTLY ".rodata..mutable.read_mostly"
#define RODATA_MUTABLE ".rodata..mutable"
#define BSS_MUTABLE ".bss..mutable"

extern bool enabled;
extern bool verbose;

bool is_const_section(const char *name);
void handle_global_variables(void *event_data __unused, void *data __unused);
void finish_type(void *event_data, void *data __unused);

static inline const_tree get_inner_type(const_tree decl)
{
	return strip_array_types(TREE_TYPE(decl));
}

// gcc passes
#if BUILDING_GCC_VERSION >= 4009
gimple_opt_pass *make_pass_instrument_mutable_writes(gcc::context *);
gimple_opt_pass *make_pass_check_local_variables(gcc::context *);
#else
struct opt_pass *make_pass_instrument_mutable_writes(void);
struct opt_pass *make_pass_check_local_variables(void);
#endif

#endif
