/*
 * Copyright 2018-2020 by PaX Team <pageexec@freemail.hu>
 * Licensed under the GPL v2
 *
 *
 */

#include "utilities.h"

const char *asm_include;

static const struct gcc_debug_hooks *old_debug_hooks;
static struct gcc_debug_hooks utilities_debug_hooks;

static void utilities_assembly_start(void)
{
	// chain to previous callback
	if (old_debug_hooks && old_debug_hooks->assembly_start)
		old_debug_hooks->assembly_start();

	fprintf(asm_out_file, "\t.include \"%s\"\n", asm_include);
}

static void (*old_finish)(void);
static void utilities_finish(void)
{
	deps_add_dep(cpp_get_deps(parse_in), asm_include);
	old_finish();
}

void asm_include_start_unit(void __unused *gcc_data, void __unused *user_data)
{
	if (debug_hooks)
		utilities_debug_hooks = *debug_hooks;
	utilities_debug_hooks.assembly_start = utilities_assembly_start;

	old_debug_hooks = debug_hooks;
	debug_hooks = &utilities_debug_hooks;

	old_finish = lang_hooks.finish;
	lang_hooks.finish = utilities_finish;
}
